Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vdifc.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vdifc.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vdifc.F	(revision 227)
@@ -38,6 +38,6 @@
 !     ------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 #include "comcstfi.h"
 #include "callkeys.h"
@@ -77,17 +77,17 @@
 
       REAL z4st,zdplanck(ngrid)
-      REAL zkv(ngrid,nlayermx+1),zkh(ngrid,nlayermx+1)
+      REAL zkv(ngrid,nlay+1),zkh(ngrid,nlay+1)
       REAL zcdv(ngrid),zcdh(ngrid)
       REAL zcdv_true(ngrid),zcdh_true(ngrid)
-      REAL zu(ngrid,nlayermx),zv(ngrid,nlayermx)
-      REAL zh(ngrid,nlayermx)
+      REAL zu(ngrid,nlay),zv(ngrid,nlay)
+      REAL zh(ngrid,nlay)
       REAL ztsrf2(ngrid)
       REAL z1(ngrid),z2(ngrid)
-      REAL za(ngrid,nlayermx),zb(ngrid,nlayermx)
-      REAL zb0(ngrid,nlayermx)
-      REAL zc(ngrid,nlayermx),zd(ngrid,nlayermx)
+      REAL za(ngrid,nlay),zb(ngrid,nlay)
+      REAL zb0(ngrid,nlay)
+      REAL zc(ngrid,nlay),zd(ngrid,nlay)
       REAL zcst1
       REAL zu2!, a
-      REAL zcq(ngrid,nlayermx),zdq(ngrid,nlayermx)
+      REAL zcq(ngrid,nlay),zdq(ngrid,nlay)
       REAL evap(ngrid)
       REAL zcq0(ngrid),zdq0(ngrid)
@@ -96,4 +96,5 @@
       LOGICAL firstcall
       SAVE firstcall
+!$OMP THREADPRIVATE(firstcall)
       
       LOGICAL lastcall
@@ -101,8 +102,9 @@
 !     variables added for CO2 condensation
 !     ------------------------------------
-      REAL hh                   !, zhcond(ngrid,nlayermx)
+      REAL hh                   !, zhcond(ngrid,nlay)
 !     REAL latcond,tcond1mb
 !     REAL acond,bcond
 !     SAVE acond,bcond
+!!$OMP THREADPRIVATE(acond,bcond)
 !     DATA latcond,tcond1mb/5.9e5,136.27/
 
@@ -110,5 +112,5 @@
 !     -------
       INTEGER iq
-      REAL zq(ngrid,nlayermx,nq)
+      REAL zq(ngrid,nlay,nq)
       REAL zq1temp(ngrid)
       REAL rho(ngrid)         ! near-surface air density
@@ -123,6 +125,6 @@
       real z1_T(ngrid), z2_T(ngrid)
       real zb_T(ngrid)
-      real zc_T(ngrid,nlayermx)
-      real zd_T(ngrid,nlayermx)
+      real zc_T(ngrid,nlay)
+      real zd_T(ngrid,nlay)
       real lat1(ngrid), lat2(ngrid)
       real surfh2otot
@@ -132,4 +134,5 @@
       integer ivap, iice ! also make liq for clarity on surface...
       save ivap, iice
+!$OMP THREADPRIVATE(ivap,iice)
 
       real, parameter :: karman=0.4
@@ -249,5 +252,5 @@
 !     ------------------------------------------------------ 
 
-      call vdif_kc(ngrid,ptimestep,g,pzlev,pzlay
+      call vdif_kc(ngrid,nlay,ptimestep,g,pzlev,pzlay
      &     ,pu,pv,ph,zcdv_true
      &     ,pq2,zkv,zkh)
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vlz_fi.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vlz_fi.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/vlz_fi.F	(revision 227)
@@ -1,3 +1,3 @@
-      SUBROUTINE vlz_fi(ngrid,q,pente_max,masse,w,wq)
+      SUBROUTINE vlz_fi(ngrid,nlayer,q,pente_max,masse,w,wq)
 c
 c     Auteurs:   P.Le Van, F.Hourdin, F.Forget 
@@ -16,6 +16,6 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "dimphys.h"
+!#include "dimensions.h"
+!#include "dimphys.h"
 
 c
@@ -23,9 +23,9 @@
 c   Arguments:
 c   ----------
-      integer ngrid
-      real masse(ngrid,llm),pente_max
-      REAL q(ngrid,llm)
-      REAL w(ngrid,llm)
-      REAL wq(ngrid,llm+1)
+      integer,intent(in) :: ngrid, nlayer
+      real,intent(in) :: masse(ngrid,nlayer),pente_max
+      REAL,INTENT(INOUT) :: q(ngrid,nlayer)
+      REAL,INTENT(INOUT) :: w(ngrid,nlayer)
+      REAL,INTENT(OUT) :: wq(ngrid,nlayer+1)
 c
 c      Local 
@@ -35,5 +35,6 @@
 c
 
-      real dzq(ngrid,llm),dzqw(ngrid,llm),adzqw(ngrid,llm),dzqmax
+      real dzq(ngrid,nlayer),dzqw(ngrid,nlayer),adzqw(ngrid,nlayer)
+      real dzqmax
       real newmasse
       real sigw, Mtot, MQtot
@@ -47,5 +48,5 @@
 c    sens de W
 
-      do l=2,llm
+      do l=2,nlayer
          do ij=1,ngrid
             dzqw(ij,l)=q(ij,l-1)-q(ij,l)
@@ -54,5 +55,5 @@
       enddo
 
-      do l=2,llm-1
+      do l=2,nlayer-1
          do ij=1,ngrid
 #ifdef CRAY
@@ -73,5 +74,5 @@
       do ij=1,ngrid
          dzq(ij,1)=0.
-         dzq(ij,llm)=0.
+         dzq(ij,nlayer)=0.
       enddo
 c ---------------------------------------------------------------
@@ -83,5 +84,5 @@
 c      No flux at the model top:
        do ij=1,ngrid
-          wq(ij,llm+1)=0.
+          wq(ij,nlayer+1)=0.
        enddo
 
@@ -89,5 +90,5 @@
 c      ===============================
 
-       do l = 1,llm          ! loop different than when w<0
+       do l = 1,nlayer          ! loop different than when w<0
         do ij=1,ngrid
 
@@ -107,13 +108,13 @@
             Mtot = masse(ij,m)
             MQtot = masse(ij,m)*q(ij,m)
-            if(m.ge.llm)goto 88
+            if(m.ge.nlayer)goto 88
             do while(w(ij,l).gt.(Mtot+masse(ij,m+1)))
                 m=m+1
                 Mtot = Mtot + masse(ij,m)
                 MQtot = MQtot + masse(ij,m)*q(ij,m)
-                if(m.ge.llm)goto 88
+                if(m.ge.nlayer)goto 88
             end do
  88         continue
-            if (m.lt.llm) then
+            if (m.lt.nlayer) then
                 sigw=(w(ij,l)-Mtot)/masse(ij,m+1)
                 wq(ij,l)=(MQtot + (w(ij,l)-Mtot)*
@@ -137,5 +138,5 @@
        end do
 
-       do l = 1,llm-1  ! loop different than when w>0
+       do l = 1,nlayer-1  ! loop different than when w>0
         do ij=1,ngrid
          if(w(ij,l+1).le.0)then
@@ -176,5 +177,5 @@
  99    continue
 
-      do l=1,llm
+      do l=1,nlayer
          do ij=1,ngrid
 
@@ -191,5 +192,3 @@
 
 
-
-      return
       end
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/watercommon_h.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/watercommon_h.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/watercommon_h.F90	(revision 227)
@@ -19,4 +19,5 @@
 
       real, save :: epsi, RCPD, RCPV, RV, RVTMP2
+!$OMP THREADPRIVATE(epsi,RCPD,RCPV,RV,RVTMP2)
       
       contains
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagfi.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagfi.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagfi.F	(revision 227)
@@ -68,4 +68,5 @@
 
       real*4,save :: date
+!$OMP THREADPRIVATE(date)
 
       REAL phis(ip1jmp1)
@@ -78,7 +79,9 @@
       integer,save :: zitau=0
       character(len=20),save :: firstnom='1234567890'
+!$OMP THREADPRIVATE(zitau,firstnom)
 
 ! Ajouts
       integer, save :: ntime=0
+!$OMP THREADPRIVATE(ntime)
       integer :: idim,varid
       integer :: nid
@@ -95,4 +98,5 @@
       character(len=120),save :: nom_def(n_nom_def_max)
       logical,save :: firstcall=.true.
+!$OMP THREADPRIVATE(firstcall) 	!diagfi_def,n_nom_def,nom_def read in diagfi.def
       
 #ifndef MESOSCALE
@@ -128,4 +132,5 @@
          firstcall=.false.
 
+!$OMP MASTER
   !      Open diagfi.def definition file if there is one:
          open(99,file="diagfi.def",status='old',form='formatted',
@@ -151,4 +156,6 @@
             diagfi_def=.false.
          endif
+!$OMP END MASTER
+!$OMP BARRIER
       END IF ! of IF (firstcall)
 
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagsoil.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagsoil.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagsoil.F90	(revision 227)
@@ -46,4 +46,5 @@
 character(len=20),save :: firstname="1234567890"
 integer,save :: zitau=0
+!$OMP THREADPRIVATE(date,isample,ntime,firstname,zitau)
 
 character(len=30) :: filename="diagsoil.nc"
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagspecIR.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagspecIR.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagspecIR.F	(revision 227)
@@ -54,5 +54,5 @@
 ! Commons
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "paramet.h"
 !#include "control.h"
@@ -91,7 +91,9 @@
       data firstnom /'1234567890'/
       data zitau /0/
+!$OMP THREADPRIVATE(firstnom,zitau,date)
 
 ! Ajouts
       integer, save :: ntime=0
+!$OMP THREADPRIVATE(ntime)
       integer :: idim,varid
       integer :: nid
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagspecVI.F
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagspecVI.F	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/writediagspecVI.F	(revision 227)
@@ -54,5 +54,5 @@
 ! Commons
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "paramet.h"
 !#include "control.h"
@@ -91,7 +91,9 @@
       data firstnom /'1234567890'/
       data zitau /0/
+!$OMP THREADPRIVATE(firstnom,zitau,date)
 
 ! Ajouts
       integer, save :: ntime=0
+!$OMP THREADPRIVATE(ntime)
       integer :: idim,varid
       integer :: nid
Index: codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/wstats.F90
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/wstats.F90	(revision 224)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/LMDZ.COMMON/libf/phystd/wstats.F90	(revision 227)
@@ -7,5 +7,5 @@
 
 #include "dimensions.h"
-#include "dimphys.h"
+!#include "dimphys.h"
 #include "comconst.h"
 #include "statto.h"
@@ -22,4 +22,5 @@
 character (len=50) :: namebis
 character (len=50), save :: firstvar
+!$OMP THREADPRIVATE(firstvar)
 integer :: ierr,varid,nbdim,nid
 integer :: meanid,sdid
@@ -30,4 +31,5 @@
 
 integer, save :: step=0
+!$OMP THREADPRIVATE(firstcall,indx,step)
 
 ! Added to work in parallel mode
@@ -293,5 +295,5 @@
 
 include "dimensions.h"
-include "dimphys.h"
+!include "dimphys.h"
 include "netcdf.inc"
 
